#!hs2
# regexp.hsc
# This Scripts purpose is testing regular expressions (regexp)
# This Script can be used interactively or the input can be two files

# Interactiv:
# First you enter your teststring
# Second you enter your testregexp
# In the Hamsterlog you can see which part of your teststring matched
# against the regexp

# Non-Interactiv:
# You create two files. One with your teststring. Each line is read as a string.
# Its name must be `teststrings.txt'. The other file must be named `testregexps.txt'.
# Each line is read as one regexp. Each line of the second file ist matched against
# all lines of the first file. Look at the value of `$filepath'.
# This variable holds the value of the path to your testfiles.

# Be careful! In the syntax for the Hamster-scorefiles, a regexp is indicated 
# by enclosing it in `{' and `}'. These ar not part of the regexp, so you need'nt
# use them here in this script.
# Also remember that if you write a rule like '-100 From: I hate him <idiot@spammers.com>'
# to match against a header like 'From: ...' you needn't write 'From' in your string to 
# test the regexp. The relevant string ist only the part after 'From: ' 

varset($string, "") # teststring
varset($regexp, "") # testregexp
varset($question, 6) # needed for the loop
varset($filepath, "c:/Programme/hamster/Script/Test/")
varset($teststringsfile, $filepath + "teststrings.txt")
varset($testregexpfile, $filepath + "testregexps.txt")
var( $stringslist, $regexpslist, $i, $k, $b1, $b2)

$question = MsgBox("Interactiv?", "File or interactiv", 0x3) 
                   # 7 no; 6 yes; 2 cancel

icase($question, 2, abbruch,_
		 6, Interactiv,_
		 7, Non_Interactiv)
quit

sub Interactiv
  while($question = 6)
    $string = InputBox("Enter teststring ","",$string, $question)
    if($question <> 1)
      quit
    endif
    $regexp = InputBox("Enter regexpstring ","",$regexp, $question)
    if($question <> 1)
      quit
    endif
    Match
    $question = MsgBox("Again?","", 0x4)
  endwhile
endsub

sub Non_Interactiv
  $stringslist = ListAlloc
  $regexpslist = ListAlloc
  $b1 = ListLoad($stringslist, $teststringsfile)
  $b2 = ListLoad($regexpslist, $testregexpfile)
  if(($b1 = -3) || ($b2 = -3))
    print("File not found")
    print("Current directory is " + DirCurrent)
  endif
  for($i, 0, ListCount($regexpslist) - 1)
    $regexp = ListGet($regexpslist, $i)
    for($k, 0, ListCount($stringslist) - 1)
      $string = ListGet($stringslist, $k)
      Match
    endfor
  endfor    
  ListFree($stringslist)
  ListFree($regexpslist)  
endsub

sub Match
  if(RE_Match($string, $regexp))
    print("String -> ", $string, " <- matches with -> ",_
	  $regexp, " <- to ", RE_Extract($string, $regexp))
  else
    print("String ", $string, " does not match ", $regexp)
  endif    
endsub
      
	  
sub abbruch
    quit
endsub

quit